package com.gic.haoban.manage.service.dao.mapper;

import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkRelation;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

public interface TabHaobanStaffClerkRelationMapper {
    int deleteByPrimaryKey(String staffClerkRelationId);

    int insert(TabHaobanStaffClerkRelation record);

    int insertSelective(TabHaobanStaffClerkRelation record);

    TabHaobanStaffClerkRelation selectByPrimaryKey(String staffClerkRelationId);

    int updateByPrimaryKeySelective(TabHaobanStaffClerkRelation record);

    int updateByPrimaryKey(TabHaobanStaffClerkRelation record);

	List<TabHaobanStaffClerkRelation> listBindCode(@Param("enterpriseId")String enterpriseId, @Param("clerkCodeList")Set<String> clerkCodeList);

	List<TabHaobanStaffClerkRelation> listBindCodeByStaffId(@Param("enterpriseIdList")List<String> enterpriseIdList, @Param("staffId")String staffId);

    TabHaobanStaffClerkRelation getOneByClerkId(@Param("clerkId") String clerkId);

    /**
     * 改变状态 格局clerkId
     *
     * @param clerkId
     * @param status
     * @return
     */
    int changeStatusByClerkId(@Param("clerkId") String clerkId, @Param("status") Integer status);

    /**
     * 更新信息
     * @param record
     * @return
     */
    int updateByClerkId(TabHaobanStaffClerkRelation record);

    /**
     * 格局clerkId 查询staffClerkRelation
     *
     * @param clerkId
     * @param wxEnterpriseId
     * @return
     */
    TabHaobanStaffClerkRelation getBindByClerkId(@Param("clerkId") String clerkId,@Param("wxEnterpriseId") String wxEnterpriseId);
    
    TabHaobanStaffClerkRelation getByCodeAndEnterpriseId(@Param("clerkCode")String clerkCode, @Param("enterpriseId")String enterpriseId);
    /**
     * 解绑
     */
    void delByStoreIdAndCode( @Param("storeId")String storeId,@Param("clerkCode")String clerkCode);
    
    
    List<TabHaobanStaffClerkRelation> listByClerkIds(@Param("clerkIds") List<String> clerkIds);

    List<TabHaobanStaffClerkRelation> listByStoreId(@Param("storeId")String storeId);
    
    TabHaobanStaffClerkRelation getOneByStoreIdAndStaffId(@Param("storeId")String storeId,@Param("staffId")String staffId);

    /**
     * 解绑
     */
    int cleanStaffDepart( @Param("wxEnterpriseId")String wxEnterpriseId,@Param("staffIds")List<String> staffIds);

    TabHaobanStaffClerkRelation getOneBindCodeNoStatus(@Param("enterpriseId")String enterpriseId, @Param("clerkCode")String clerkCode);

    TabHaobanStaffClerkRelation getOneBindStoreId(@Param("staffId")String staffId, @Param("storeId")String storeId);

	TabHaobanStaffClerkRelation getByClerkId(@Param("clerkId")String clerkId);

	TabHaobanStaffClerkRelation getByClerkIdNoStatus(@Param("clerkId")String clerkId);

	int delByPrimaryKey(@Param("staffClerkRelationId")String staffClerkRelationId);
	
	void delByClerkId(@Param("clerkId")String clerkId);
	
	List<TabHaobanStaffClerkRelation>listByEnterpriseIdAndWxUserId(@Param("enterpriseId")String enterpriseId,@Param("wxUserId")String wxUserId);

	List<TabHaobanStaffClerkRelation> lisByStaffId(@Param("wxEnterpriseId")String wxEnterpriseId, @Param("staffId")String staffId);

	TabHaobanStaffClerkRelation getByCodeAndStoreId(@Param("clerkCode")String clerkCode, @Param("storeId")String storeId);
	
	List<TabHaobanStaffClerkRelation> listByWxEnterpriseId(@Param("wxEnterpriseId")String wxEnterpriseId);

	List<TabHaobanStaffClerkRelation> pageByWxEnterpriseId(@Param("wxEnterpriseId")String wxEnterpriseId);

    List<TabHaobanStaffClerkRelation> listBindByStoreId(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("storeId") String storeId);

    /**
     * 授权绑定的列表
     *
     * @param wxEnterpriseId
     * @param storeIds
     * @return
     */
    List<TabHaobanStaffClerkRelation> listBindByStoreIds(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("storeIds") Set<String> storeIds);

    /**
     * 授权绑定的列表
     *
     * @param wxEnterpriseId
     * @param storeIds
     * @return
     */
    List<TabHaobanStaffClerkRelation> listBindNotInStoreIds(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("enterpriseId") String enterpriseId, @Param("storeIds") Set<String> storeIds);

    /**
     * 删除绑定根据门店
     *
     * @param storeIds
     */
    void delByStoreIds(@Param("storeIds") Set<String> storeIds);

    /**
     * 已使用的门店id列表
     *
     * @param enterpriseId
     */
    List<TabHaobanStaffClerkRelation> listBindStoreIdByEnterpriseId(String enterpriseId);


    /**
     * 列出所有
     *
     * @return {@link List<TabHaobanStaffClerkRelation> }
     * @author xuwenqian
     * @date 2021-07-15 16:24:27
     */
    List<StaffClerkRelationDTO> listAll();
}